import { FieldProps } from 'formik';
import React, { useCallback, useMemo, FunctionComponent } from 'react';

import { Fieldset, FormField, Label, Legend, TextArea } from '../ui/form';

const OrderComments: FunctionComponent = () => {
    const renderLabel = useCallback(name => (
        <Label hidden htmlFor={ name }>
            Order Comments or Shipping Account Number
        </Label>
    ), []);

    const renderInput = useCallback(({ field }: FieldProps) => (
        <TextArea
            { ...field }
            maxLength={ 2000 }
        />
    ), []);

    const legend = useMemo(() => (
        <Legend>
            Order Comments or Shipping Account Number
        </Legend>
    ), []);

    return <Fieldset legend={ legend } testId="checkout-shipping-comments">
        <FormField
            input={ renderInput }
            label={ renderLabel }
            name="orderComment"
        />
    </Fieldset>;
};

export default OrderComments;
